Index: /pjproject/trunk/pjlib/include/pj/compat/cc_armcc.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/cc_armcc.h	(revision 4623)
+++ /pjproject/trunk/pjlib/include/pj/compat/cc_armcc.h	(revision 4624)
@@ -44,4 +44,5 @@
 #define PJ_NORETURN		
 #define PJ_ATTR_NORETURN	__attribute__ ((noreturn))
+#define PJ_ATTR_MAY_ALIAS	__attribute__ ((__may_alias__))
 
 #define PJ_HAS_INT64		1
Index: /pjproject/trunk/pjlib/include/pj/compat/cc_codew.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/cc_codew.h	(revision 4623)
+++ /pjproject/trunk/pjlib/include/pj/compat/cc_codew.h	(revision 4624)
@@ -40,4 +40,5 @@
 #define PJ_NORETURN		
 #define PJ_ATTR_NORETURN	
+#define PJ_ATTR_MAY_ALIAS	
 
 #define PJ_HAS_INT64		1
Index: /pjproject/trunk/pjlib/include/pj/compat/cc_gcc.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/cc_gcc.h	(revision 4623)
+++ /pjproject/trunk/pjlib/include/pj/compat/cc_gcc.h	(revision 4624)
@@ -54,4 +54,5 @@
   #define PJ_INLINE_SPECIFIER	static __inline
   #define PJ_ATTR_NORETURN	
+  #define PJ_ATTR_MAY_ALIAS	
 #else
   typedef long long		pj_int64_t;
@@ -59,4 +60,5 @@
   #define PJ_INLINE_SPECIFIER	static inline
   #define PJ_ATTR_NORETURN	__attribute__ ((noreturn))
+  #define PJ_ATTR_MAY_ALIAS	__attribute__((__may_alias__))
 #endif
 
Index: /pjproject/trunk/pjlib/include/pj/compat/cc_gcce.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/cc_gcce.h	(revision 4623)
+++ /pjproject/trunk/pjlib/include/pj/compat/cc_gcce.h	(revision 4624)
@@ -40,4 +40,5 @@
 #define PJ_NORETURN		
 #define PJ_ATTR_NORETURN	__attribute__ ((noreturn))
+#define PJ_ATTR_MAY_ALIAS	__attribute__ ((__may_alias__))
 
 #define PJ_HAS_INT64		1
Index: /pjproject/trunk/pjlib/include/pj/compat/cc_msvc.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/cc_msvc.h	(revision 4623)
+++ /pjproject/trunk/pjlib/include/pj/compat/cc_msvc.h	(revision 4624)
@@ -69,4 +69,5 @@
 #define PJ_NORETURN		__declspec(noreturn)
 #define PJ_ATTR_NORETURN	
+#define PJ_ATTR_MAY_ALIAS	
 
 #define PJ_HAS_INT64	1
Index: /pjproject/trunk/pjlib/include/pj/compat/cc_mwcc.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/cc_mwcc.h	(revision 4623)
+++ /pjproject/trunk/pjlib/include/pj/compat/cc_mwcc.h	(revision 4624)
@@ -40,4 +40,5 @@
 #define PJ_NORETURN		
 #define PJ_ATTR_NORETURN	__attribute__ ((noreturn))
+#define PJ_ATTR_MAY_ALIAS	
 
 #define PJ_HAS_INT64		1
Index: /pjproject/trunk/pjlib/include/pj/list.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/list.h	(revision 4623)
+++ /pjproject/trunk/pjlib/include/pj/list.h	(revision 4624)
@@ -75,5 +75,5 @@
 {
     PJ_DECL_LIST_MEMBER(void);
-};
+} PJ_ATTR_MAY_ALIAS; /* may_alias avoids warning with gcc-4.4 -Wall -O2 */
 
 
Index: /pjproject/trunk/pjlib/src/pj/log.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/log.c	(revision 4623)
+++ /pjproject/trunk/pjlib/src/pj/log.c	(revision 4624)
@@ -108,5 +108,5 @@
 }
 
-static int log_get_raw_indent()
+static int log_get_raw_indent(void)
 {
     return (long)(pj_ssize_t)pj_thread_local_get(thread_indent_tls_id);
@@ -120,5 +120,5 @@
 }
 
-static int log_get_raw_indent()
+static int log_get_raw_indent(void)
 {
     return log_indent;
@@ -126,5 +126,5 @@
 #endif	/* PJ_LOG_ENABLE_INDENT && PJ_HAS_THREADS */
 
-static int log_get_indent()
+static int log_get_indent(void)
 {
     int indent = log_get_raw_indent();
Index: /pjproject/trunk/pjlib/src/pj/pool_buf.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/pool_buf.c	(revision 4623)
+++ /pjproject/trunk/pjlib/src/pj/pool_buf.c	(revision 4624)
@@ -44,5 +44,5 @@
 }
 
-static pj_status_t pool_buf_initialize()
+static pj_status_t pool_buf_initialize(void)
 {
     pj_atexit(&pool_buf_cleanup);
Index: /pjproject/trunk/pjlib/src/pj/ssl_sock_ossl.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/ssl_sock_ossl.c	(revision 4623)
+++ /pjproject/trunk/pjlib/src/pj/ssl_sock_ossl.c	(revision 4624)
@@ -611,6 +611,6 @@
     ssock->ossl_rbio = BIO_new(BIO_s_mem());
     ssock->ossl_wbio = BIO_new(BIO_s_mem());
-    BIO_set_close(ssock->ossl_rbio, BIO_CLOSE);
-    BIO_set_close(ssock->ossl_wbio, BIO_CLOSE);
+    (void)BIO_set_close(ssock->ossl_rbio, BIO_CLOSE);
+    (void)BIO_set_close(ssock->ossl_wbio, BIO_CLOSE);
     SSL_set_bio(ssock->ossl_ssl, ssock->ossl_rbio, ssock->ossl_wbio);
 
@@ -1274,5 +1274,5 @@
 
     /* Reset write BIO */
-    BIO_reset(ssock->ossl_wbio);
+    (void)BIO_reset(ssock->ossl_wbio);
 
     /* Ticket #1573: Don't hold mutex while calling PJLIB socket send(). */
Index: /pjproject/trunk/pjmedia/src/test/test.c
===================================================================
--- /pjproject/trunk/pjmedia/src/test/test.c	(revision 4623)
+++ /pjproject/trunk/pjmedia/src/test/test.c	(revision 4624)
@@ -48,8 +48,8 @@
  */
 #if PJMEDIA_HAS_G711_CODEC==0
-int dummy()
+void *dummy()
 {
     // Dummy
-    return (int) &pjmedia_plc_save;
+    return &pjmedia_plc_save;
 }
 #endif
Index: /pjproject/trunk/pjsip-apps/src/samples/icedemo.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/samples/icedemo.c	(revision 4623)
+++ /pjproject/trunk/pjsip-apps/src/samples/icedemo.c	(revision 4624)
@@ -515,7 +515,7 @@
 }
 
-#define PRINT(fmt, arg0, arg1, arg2, arg3, arg4, arg5)	    \
+#define PRINT(...)	    \
 	printed = pj_ansi_snprintf(p, maxlen - (p-buffer),  \
-				   fmt, arg0, arg1, arg2, arg3, arg4, arg5); \
+				   __VA_ARGS__); \
 	if (printed <= 0 || printed >= (int)(maxlen - (p-buffer))) \
 	    return -PJ_ETOOSMALL; \
@@ -541,6 +541,5 @@
 
     PRINT("%s\n",
-	  pj_ice_get_cand_type_name(cand->type),
-	  0, 0, 0, 0, 0);
+	  pj_ice_get_cand_type_name(cand->type));
 
     if (p == buffer+maxlen)
@@ -564,6 +563,5 @@
 
     /* Write "dummy" SDP v=, o=, s=, and t= lines */
-    PRINT("v=0\no=- 3414953978 3414953978 IN IP4 localhost\ns=ice\nt=0 0\n", 
-	  0, 0, 0, 0, 0, 0);
+    PRINT("v=0\no=- 3414953978 3414953978 IN IP4 localhost\ns=ice\nt=0 0\n");
 
     /* Get ufrag and pwd from current session */
@@ -576,6 +574,5 @@
 	   local_ufrag.ptr,
 	   (int)local_pwd.slen,
-	   local_pwd.ptr, 
-	   0, 0);
+	   local_pwd.ptr);
 
     /* Write each component */
@@ -597,6 +594,5 @@
 		  (int)pj_sockaddr_get_port(&cand[0].addr),
 		  pj_sockaddr_print(&cand[0].addr, ipaddr,
-				    sizeof(ipaddr), 0),
-		  0, 0, 0, 0);
+				    sizeof(ipaddr), 0));
 	} else if (comp==1) {
 	    /* For component 2, default address is in a=rtcp line */
@@ -604,6 +600,5 @@
 		  (int)pj_sockaddr_get_port(&cand[0].addr),
 		  pj_sockaddr_print(&cand[0].addr, ipaddr,
-				    sizeof(ipaddr), 0),
-		  0, 0, 0, 0);
+				    sizeof(ipaddr), 0));
 	} else {
 	    /* For other components, we'll just invent this.. */
@@ -611,6 +606,5 @@
 		  (int)pj_sockaddr_get_port(&cand[0].addr),
 		  pj_sockaddr_print(&cand[0].addr, ipaddr,
-				    sizeof(ipaddr), 0),
-		  0, 0, 0, 0);
+				    sizeof(ipaddr), 0));
 	}
 